<?php
/**
 * @package		JSMigrator
 * @copyright (C) 2008 by Slashes & Dots Sdn Bhd - All rights reserved!
 * @license http://www.azrul.com Copyrighted Commercial Software
 */

// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

// @todo: Do some check if user is really allowed to access this section of the back end.
// Just in case we need to impose ACL on the component

// During ajax calls, the following constant might not be called
if( !defined('JPATH_COMPONENT') )
{
	define( 'JPATH_COMPONENT' , dirname( __FILE__ ) );
}

// Load necessary language file since we dont store it in the language folder
$lang =& JFactory::getLanguage();
$lang->load( 'com_jsmigrator', JPATH_COMPONENT );

// Load any helpers
require_once( JPATH_COMPONENT . DS . 'helpers' . DS . 'jsmigrator.php' );

// Load any defined properties
require_once( JPATH_COMPONENT . DS . 'defines.php' );

// Require the base controller
require_once( JPATH_COMPONENT . DS . 'controllers' . DS . 'controller.php' );

// Set the tables path
JTable::addIncludePath( JPATH_COMPONENT . DS . 'tables' );

// Get the task
$task	= JRequest::getCmd( 'task' , 'display' );

// Load the required libraries
if( !class_exists( 'AzrulJXCachedTemplate' ) )
{
	require_once( JPATH_PLUGINS . DS . 'system' . DS . 'pc_includes' . DS . 'template.php' );
}

// Load the required libraries
if( !defined( 'JAX_SITE_ROOT' ) )
{
	require_once( JPATH_PLUGINS . DS . 'system' . DS . 'pc_includes' . DS . 'ajax.php' );
}

// Load AJAX library for the back end.
$jax	= new JAX( JURI::root() . 'plugins/system/pc_includes' );
$jax->setReqURI( JURI::base() . 'index2.php' );

// Override previously declared jax_live_site stuffs
if( !$jax->process() )
{
	echo $jax->getScript();
}

// Let's test if the task is azrul_ajax , we skip the controller part at all.
if( isset( $task ) && ( $task == 'azrul_ajax' ) )
{
	require_once( JPATH_COMPONENT . DS . 'ajax.jsmigrator.php' );
}
else
{
	// We treat the view as the controller. Load other controller if there is any.
	$controller	= JRequest::getWord( 'view' , 'jsmigrator' );

	if( !empty( $controller ) )
	{
		$controller	= JString::strtolower( $controller );
		$path		= JSMIGRATOR_CONTROLLERS . DS . $controller . '.php';
	
		// Test if the controller really exists
		if( file_exists( $path ) )
		{
			require_once( $path );
		}
		else
		{
			JError::raiseError( 500 , JText::_( 'Invalid Controller. File does not exists in this context.' ) );
		}
	}
	
	$class	= 'JsmigratorController' . JString::ucfirst( $controller );
	
	// Test if the object really exists in the current context
	if( class_exists( $class ) )
	{
		$controller	= new $class();
	}
	else
	{
		// Throw some errors if the system is unable to locate the object's existance
		JError::raiseError( 500 , 'Invalid Controller Object. Class definition does not exists in this context.' );
	}
	
	// Task's are methods of the controller. Perform the Request task
	$controller->execute( $task );
	
	// Redirect if set by the controller
	$controller->redirect();
}