<?php
/**
 * @package		JSMigrator
 * @copyright (C) 2008 by Slashes & Dots Sdn Bhd - All rights reserved!
 * @license http://www.azrul.com Copyrighted Commercial Software
 */
// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.controller' );
jimport( 'joomla.utilities.date' );

//load the comprofiler language test				
$cbLangPath	= dirname( dirname( JPATH_COMPONENT ) ) . DS . 'components' . DS . 'com_comprofiler' . DS . 'language';
if( file_exists( $cbLangPath . DS . 'english.php' ) )
{
	global $mainframe;
	$tmpPath = $mainframe->getCfg( 'absolute_path' );
	if(empty($tmpPath))
	{
		$lang =& JApplication::getCfg('lang');
		$UElanguagePath		=	JPATH_ROOT . DS .'/components/com_comprofiler/plugin/language';
		if ( file_exists( $UElanguagePath.'/' . $lang . '/' . $lang . '.php' ) ) {
			include_once( $UElanguagePath . '/' . $lang. '/' . $lang . '.php' );
		} else {
			include_once( $UElanguagePath . '/default_language/default_language.php' );
		}		
	}
	else
	{	
		include_once($cbLangPath . DS . 'english.php');
	}	
}//end if

/**
 * Jom Social Component Controller
 */
class JsmigratorControllerTools extends JsmigratorController
{

	function __construct()
	{
		parent::__construct();
	}
	
	function checkMigrateTables(){
		$db =& JFactory::getDBO();
		
		//migrator table
		$query	=	"CREATE TABLE IF NOT EXISTS `#__jsmigrator_migrator` (";
		$query	.=	"`id` int(10) unsigned NOT NULL auto_increment,";
		$query	.=	"`table_name` varchar(200) NOT NULL,";
		$query	.=	"`user_id` int(10) unsigned NOT NULL,";
		$query	.=	"`status` int(10) unsigned NOT NULL DEFAULT 0,";
		$query	.=	"`description` varchar(200) NULL,";
		$query	.=	"PRIMARY KEY  (`id`),";
		$query	.=	"KEY `table_name` (`table_name`),";
		$query	.=	"KEY `user_id` (`user_id`),";
		$query	.=	"KEY `status` (`status`)";
		$query	.=	") ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";		
		
		$db->setQuery( $query );
		$db->query();
		
		if($db->getErrorNum())
		{		
			JError::raiseError( 500, $db->stderr());			
		}
		
		//migrator - fields table
		$query	=	"CREATE TABLE IF NOT EXISTS `#__jsmigrator_migrator_fields` (";
		$query	.=	"`id` int(10) unsigned NOT NULL auto_increment,";
		$query	.=	"`cb_fieldid` int(10) unsigned NOT NULL,";
		$query	.=	"`js_fieldid` int(10) unsigned NOT NULL,";
		$query	.=	"`js_parentid` int(10) unsigned DEFAULT 0,";
		$query	.=	"`type` varchar(50) NOT NULL,";			
		$query	.=	"`status` int(10) unsigned NOT NULL DEFAULT 0,";
		$query	.=	"`description` varchar(200) NULL,";
		$query	.=	"PRIMARY KEY  (`id`),";		
		$query	.=	"KEY `cb_fieldid` (`cb_fieldid`),";
		$query	.=	"KEY `js_fieldid` (`js_fieldid`),";
		$query	.=	"KEY `js_parentid` (`js_parentid`),";
		$query	.=	"KEY `type` (`type`),";
		$query	.=	"KEY `status` (`status`)";
		$query	.=	") ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";		
		
		$db->setQuery( $query );
		$db->query();
		
		if($db->getErrorNum())
		{		
			JError::raiseError( 500, $db->stderr());			
		}		
		
		return true;
	}
	
	function ajaxCbMigrator()
	{
		$db				=& JFactory::getDBO();
		
		//check whether CB installed or not.
		$cbPath	= dirname( dirname( JPATH_COMPONENT ) ) . DS . 'components' . DS . 'com_comprofiler';
		if( !file_exists( $cbPath . DS . 'admin.comprofiler.controller.php' ) )
		{
			$objResponse	= new JAXResponse();
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div><strong>Community Builder</strong> not installed. Process aborted!</div>");' );
			$objResponse->addScriptCall( 'jQuery("#icon-wait").css( "display" , "none" );' );
			return $objResponse->sendResponse();
		}//end if
		
		
		//check whether jomsocial installeed or not.
		$jsPath	= dirname( dirname( JPATH_COMPONENT ) ) . DS . 'components' . DS . 'com_community';
		if( !file_exists( $jsPath . DS . 'admin.community.php' ) )
		{
			$objResponse	= new JAXResponse();
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div><strong>JomSocial</strong> not installed. Process aborted!</div>");' );
			$objResponse->addScriptCall( 'jQuery("#icon-wait").css( "display" , "none" );' );			
			return $objResponse->sendResponse();
		}//end if		
		
		// check for migrate table already exists or not. if not create it.
		if(! $this->checkMigrateTables())
		{
			$objResponse	= new JAXResponse();
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>DB error. Migration table not found. Process aborted.</div>");' );
			$objResponse->addScriptCall( 'jQuery("#icon-wait").css( "display" , "none" );' );
			return $objResponse->sendResponse();
		}
		
		
		
		//now migrate the default cb fields
		$this->_migrateCbDefaultFields();
				
		$this->ajaxMigrateCbUser('1');

	}
	
	function _migrateCbViewHits($userId, $objResponse)
	{
		$tblMigrator	=& JTable::getInstance( 'migrator', 'JsmigratorTable' );
		$tblUser		=& JTable::getInstance( 'jsusers', 'JsmigratorTable' );
		
		//load user
		$tblUser->load( $userId );
		
		$currentView	= $tblUser->view;
		$tblUser->view	= $currentView + $tblMigrator->getCbViewCount($userId);				
		
		if($tblUser->store())
		{
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>View hits for User Id <strong>' . $userId . '</strong> updated.</div>");' );
		}
		else
		{
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Failed updating view hits for User Id <strong>' . $userId . '</strong>!</div>");' );
		}
	}	
	
	function _migrateCbDefaultFields()
	{
		$db		=& JFactory::getDBO();
		
		$fType	= array('checkbox' => 'checkbox',
					'multicheckbox' => 'checkbox',
					'date' => 'date',
					'select' => 'select',
					'password' => 'text',
					'primaryemailaddress' => 'text',
					'predefined' => 'text',
					'multiselect' => 'list',
					'emailaddress' => 'text',
					'editorta' => 'textarea',
					'textarea' => 'textarea',
					'text' => 'text',
					'radio' => 'radio',
					'webaddress' => 'text',
					'delimiter' => 'text');
					
		$fList	= array('multicheckbox' => 'multicheckbox',
					'multiselect' => 'multiselect',
					'radio' => 'radio',
					'select' => 'select');		

		//read work start here
		
		$query = "SELECT DISTINCT a.tabid, b.title, b.enabled, b.description";
		$query .= " FROM #__comprofiler_fields AS a LEFT JOIN #__jsmigrator_migrator_fields AS c";
		$query .= " ON a.tabid = c.cb_fieldid,";
		$query .= " #__comprofiler_tabs AS b";
		$query .= " WHERE a.sys = 0";
		$query .= " AND a.name NOT IN ('fbsignature', 'fbordering', 'fbviewtype')";
		$query .= " AND (a.pluginid IS NULL OR a.pluginid = 1)"; //only get the core type
		$query .= " AND c.cb_fieldid IS NULL";
		$query .= " AND a.tabid = b.tabid";
		$query .= " ORDER BY a.tabid";
		
		$db->setQuery( $query );
		$cbTabs = $db->loadObjectList();
		
		if(! empty($cbTabs))
		{
			foreach($cbTabs as $tab)
			{
				//skip the tab that contain '_UE_FB_' -> FB setting tab
				if(substr_count($tab->title, '_UE_FB_') > 0)
				{
					continue;
				}
			
				// actual work begin
				$tabid			=	$tab->tabid;
				$title			=	$tab->title;				
				$enabled		=	($tab->enabled == 1) ? 1 : 0;
				$description	=	$tab->description;
				
				if(substr_count($tab->title, '_UE_') > 0)
				{
					$title	=	(defined($tab->title)) ? constant($tab->title) : $tab->title;				
				}
				
				
				//get all the fields under this tab / group						
				$query = "SELECT `fieldid`, `name`, `title`, `description`, `type`, `maxlength`,";
				$query .= " `size`, `required`, `tabid`, `ordering`, `value`, `default`, `published`";
				$query .= " FROM `#__comprofiler_fields`";
				$query .= " WHERE `sys` = 0";
				$query .= " AND `type` != 'image'"; // not support for image type
				$query .= " AND tabid = ".$tabid;
				
				$db->setQuery( $query );
				$cbFields = $db->loadObjectList();
				
				if(! empty($cbFields))
				{
					
					$tblProfile	=& JTable::getInstance( 'profiles', 'JsmigratorTable' );
					
					//add the group
					$tblProfile->type		= 'group';
					$tblProfile->name		= $title;					
					$tblProfile->tips		= $description;
															
					$tblProfile->published	= $enabled;
					$tblProfile->visible	= $enabled;
					
					//default value
					$tblProfile->min		= 1;
					$tblProfile->max		= 100;						
					$tblProfile->required	= 1;
					
					$tblProfile->store();
					
					$jsGroupId	=	$tblProfile->id;	
					
					// register this tab / group in migrator table.
					$tblMgtField				=& JTable::getInstance( 'migratorfields', 'JsmigratorTable' );
					
					$tblMgtField->cb_fieldid	= $tabid;
					$tblMgtField->js_fieldid	= $jsGroupId;
					$tblMgtField->type			= 'group';
					$tblMgtField->status		= 1;
					$tblMgtField->description	= 'Cb custom fields tab';
					$tblMgtField->store();
					
					$groupOrder	= $tblProfile->ordering;
								
					$cbFieldsRev = array_reverse($cbFields);								

					foreach($cbFieldsRev as $field)
					{
						$tblProfile	=& JTable::getInstance( 'profiles', 'JsmigratorTable' );
						
						if(array_key_exists($field->type, $fType))
						{
							$fieldType = $fType[$field->type];
						}
						else
						{
							$fieldType = 'text';
						}
					    
					    if($field->type == 'checkbox')
					    {
					    	$tblProfile->options	= $field->title;
					    }
					    
					    if(array_key_exists($field->type, $fList))
						{
							$optionStr	= "";
							
							$query	=	"SELECT `fieldtitle` FROM `#__comprofiler_field_values`";
							$query	.=	" WHERE fieldid = ".$field->fieldid;
							$query	.=	" ORDER BY `ordering`";
							$db->setQuery( $query );
							$fdValues = $db->loadObjectList();
							
							foreach($fdValues as $val)
							{
								if(empty($optionStr))
								{
									$optionStr	=	$val->fieldtitle;
								}
								else
								{
									$optionStr	.=	"\n".$val->fieldtitle;
								}
							}//end foreach
					    	$tblProfile->options	= $optionStr;
					    }
								
						//add the group
						$tblProfile->type		= (empty($fieldType)) ? 'text' : $fieldType;
						$tblProfile->name		= $field->title;
						
						if(substr_count($field->title, '_UE_') > 0)
						{
							$tblProfile->name	=	(defined($field->title)) ? constant($field->title) : $field->title;				
						}
																		
						$tblProfile->fieldcode 	= 'FIELD_JS_'.JString::strtoupper($field->name);					
						$tblProfile->tips		= $field->description;
																
						$tblProfile->published	= $field->published;
						$tblProfile->visible	= $field->published;
						
						//default value
						$tblProfile->min		= 1;
						$tblProfile->max		= $field->maxlength;						
						$tblProfile->required	= $field->maxlength;
						
						$tblProfile->store($groupOrder);
						
						// register this field in migrator table.
						$tblMgtField				=& JTable::getInstance( 'migratorfields', 'JsmigratorTable' );
						$tblMgtField->cb_fieldid	= $field->fieldid;
						$tblMgtField->js_fieldid	= $tblProfile->id;
						$tblMgtField->js_parentid	= $jsGroupId;
						$tblMgtField->type			= 'field';
						$tblMgtField->status		= 1;
						$tblMgtField->description	= 'Cb custom fields';
						$tblMgtField->store();						
					
					}//end foreach

				}//end if				

			}//end foreach

		}//end if
	}
	
	
	function ajaxMigrateCbUser($limit)
	{
		$db				=& JFactory::getDBO();
		$objResponse	= new JAXResponse();
		
		$limitStart	= $limit - 1;
		$query	= "SELECT `user_id`, `avatar` FROM `#__comprofiler` ORDER BY `user_id` ASC LIMIT ".$limitStart.", 1";				
		
		$db->setQuery( $query );		
		$user	= $db->loadObject();
		
		if(empty($user))
		{
			$objResponse	= new JAXResponse();
			if($limit > 1)
			{			
				$objResponse->addScriptCall( 'jQuery("#icon-wait").css( "display" , "none" );' );
				$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Migration process finished.</div>");' );
			}
			else
			{
				$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Nothing to process. Action aborted. </div>");' );
			}			
			return $objResponse->sendResponse();		
		}//end if

		$tblMigrator	=& JTable::getInstance( 'migrator', 'JsmigratorTable' );
		
		
	
		if(! $tblMigrator->isCommunityUserCreated($user->user_id))
		{
			//create community user
			$tblMigrator->createCommunityUser($user->user_id);
		}
		
		//migrate avatar
		if(! empty($user->avatar))
		{			
			$this->ajaxMigrateCbAvatar($user->user_id , $user->avatar, $objResponse);
		}
		
		//migrate cb users custom fields value		
		$this->ajaxMigrateCbUserFields($user->user_id, $limit, $objResponse);
	}
	
	function ajaxMigrateCbUserFields($userId, $limit, $objResponse){
		$db				=& JFactory::getDBO();
		$table_name		= 'comprofiler';
		
		$tblMigrator	=& JTable::getInstance( 'migrator', 'JsmigratorTable' );
		
		//check whether this user already been processed previously.					
		$isProcessed	= $tblMigrator->isCbFieldsProcessed($userId);
		if($isProcessed)
		{
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Custom fields for User ID <strong>' . $userId . '</strong> have already been processed and no action will be taken now. </div>");' );
			$objResponse->addScriptCall( 'jax.call("jsmigrator","admin,tools,ajaxMigrateCbConnection","'.$userId.'","' .  $limit . '");');
			return $objResponse->sendResponse();
		}
		
		//actual work here
		set_time_limit(120); //give extra 2 mins
		
		//migrate user views hit
		$this->_migrateCbViewHits($userId, $objResponse);		
		
		// register this user in migrator table.
		$tblMigrator->table_name	= $table_name;
		$tblMigrator->user_id		= $userId;
		$tblMigrator->status		= 0;
		$tblMigrator->description	= 'CB Custom Fields Value';
		$tblMigrator->store();
		
		//get cb users values
		$query	=	"SELECT * FROM `#__comprofiler` WHERE `user_id` = ".$userId;
		$db->setQuery($query);
		$cbUserData	=	$db->loadAssoc();
		
		$tblMgtField	=& JTable::getInstance( 'migratorfields', 'JsmigratorTable' );
		$cbGroups		= $tblMgtField->getFieldGroups();
		
		$success	=	true;
		if(! empty($cbGroups))
		{
			foreach($cbGroups as $cbGrp)
			{
				$cdFields	=	$tblMgtField->getFields($cbGrp->js_fieldid);
				
				foreach($cdFields as $cdFld)
				{
					$tblFldValues	=& JTable::getInstance( 'fieldsvalues', 'JsmigratorTable' );
					$tblFldValues->user_id	=	$userId;
					$tblFldValues->field_id	=	$cdFld->js_fieldid;
					
					$fldValue	= '';
					
					//test the cb type to assign correct value.
					switch($cdFld->cbtype)
					{
						case 'date':
								$tmpDate	= $cbUserData[$cdFld->name];
								if(! empty($tmpDate))
								{
									//$tmpDate	= gmmktime( 0 , 0 , 0 , $month , $day , $year );
									$myDate = new JDate($tmpDate); //date format in cb : yyyy-mm-dd
									$tmpDate	= $myDate->toMySQL();
								}
								else
								{
									$tmpDate = '';
								}
								$fldValue	= $tmpDate;
								break;
								
						case 'checkbox' :
								$chkValue	= $cbUserData[$cdFld->name];
								$fldValue	= ($chkValue == 1) ? $cdFld->title . ',' : '';
								break;
								
						case 'delimiter' :
								$fldValue	= $cdFld->description;
								break;
								
						case 'webaddress':
								$fldValue	= $cbUserData[$cdFld->name];
								
								if(! empty($fldValue))
								{
									$fldValue	=	(substr_count(JString::strtoupper($fldValue), 'HTTP://') > 0) ? $fldValue : 'http://' . $fldValue;
								}
						
						 		break;		
						default:
								$fldValue	=	JString::str_ireplace('|*|', ',', $cbUserData[$cdFld->name]);
								break;													
					}
					
					$tblFldValues->value	=	$fldValue;
					if(! $tblFldValues->store())
					{
						$success	= false;
					}//end if					
				}//end foreach	
			
			}//end foreach		
			
		}//end if
		
		//now update the registry status
		if($success)
		{
			$tblMigrator->status		= 1;
			$tblMigrator->store();
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Custom fields for User ID <strong>' . $userId . '</strong> updated. </div>");' );		
		}
		else
		{		
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Custom fields for User ID <strong>' . $userId . '</strong> failed to update. </div>");' );
		}
		
		//now do the user connection				
		$objResponse->addScriptCall( 'jax.call("jsmigrator","admin,tools,ajaxMigrateCbConnection","'.$userId.'","' .  $limit . '");');
		return $objResponse->sendResponse();
	
	}
	
	
	/*
	 * Ajax function to migrate CB connection into JomSocial connection
	 */	 
	function ajaxMigrateCbConnection($userId, $limit)
	{		
		$db				=& JFactory::getDBO();
		$objResponse	= new JAXResponse();
		$table_name		= 'comprofiler_members';
		$friendCnt		= 0;
		
		$tblMigrator	=& JTable::getInstance( 'migrator', 'JsmigratorTable' );
		
		//check whether this user already been processed previously.					
		$isProcessed	= $tblMigrator->isConnectionProcessed($userId);
		if($isProcessed)
		{
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Connections for User ID <strong>' . $userId . '</strong> have already been processed and no action will be taken now. </div>");' );
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div> --------------------------- </div>");' );
			$objResponse->addScriptCall( 'jax.call("jsmigrator","admin,tools,ajaxMigrateCbUser","' .  ($limit + 1) . '");');
			return $objResponse->sendResponse();
		}		
		
		// actual work begin
		set_time_limit(180); //give extra 3 mins incase the user have many friends
		
		// register this user in migrator table.
		$tblMigrator->table_name	= $table_name;
		$tblMigrator->user_id		= $userId;
		$tblMigrator->status		= 0;
		$tblMigrator->description	= 'Connection';
		$tblMigrator->store();
		
		$query = "SELECT * FROM `#__comprofiler_members` WHERE `accepted` = 1 AND referenceid = ".$userId." ORDER BY `referenceid`";		
		$db->setQuery( $query );
		$members	= $db->loadObjectList();
						
		$success = true;
		foreach($members as $member)
		{
			$isPending	= ($member->pending == 1) ? true : false;
			$authorId	= $member->referenceid;
			$friendId	= $member->memberid;
			
			$tblConn		=& JTable::getInstance( 'connection', 'JsmigratorTable' );
						
			$tblConn->connect_from	= $authorId;
			$tblConn->connect_to	= $friendId;
			$tblConn->status		= ($isPending) ? 0 : 1;
						
			if(! $isPending)
			{
				$friendCnt++;
			}
			
			if(! $tblConn->store())
			{
				$success = false;
			}
		}//end foreach
		
		
		//now update friend count.
		$tblUser	=& JTable::getInstance( 'jsusers', 'JsmigratorTable' );
		$tblUser->load( $userId );
		
		$currentFriendCnt		= $tblUser->friendcount;
		$tblUser->friendcount	= $currentFriendCnt + $friendCnt;
		if(! $tblUser->store())
		{
			$success = false;
		}
				
		if($success)
		{
			//now update the entry registy status	
			$tblMigrator->status	= 1;
			$tblMigrator->store();
			
			// done. Display status message	
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>User ID <strong>' . $userId . '</strong>\'s Connection Updated</div>");' );
		} else {
			// done. Display status message	
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>User ID <strong>' . $userId . '</strong>\'s Connection update failed!</div>");' );
		}
		
		//now execute the next user
		$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div> --------------------------- </div>");' );
		$objResponse->addScriptCall( 'jax.call("jsmigrator","admin,tools,ajaxMigrateCbUser","' . ($limit + 1) . '");');

		return $objResponse->sendResponse();
	
	}//end ajaxMigrateCbConnection
	
	/*
	 * Ajax function to migrate CB avatar into JomSocial avatar
	 */	 
	function ajaxMigrateCbAvatar($userId, $cbImagePath, $objResponse){

		require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'helpers'.DS.'image.php');
		
		if(! class_exists('CFactory')) {		
			require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'core.php');			
		}
		
		$db				=& JFactory::getDBO();
		
		$imgFullPath	= str_replace('/', DS, $cbImagePath);
		$imgFullPath	= JPATH_ROOT . DS . 'images' . DS . 'comprofiler' . DS . $imgFullPath;
		
		//getting file type
		$imgArr1	=	explode(DS , $cbImagePath);
		$imgArr2	=	explode('.' , $imgArr1[count($imgArr1) - 1]); // we know the last one will always be the filename
		
		$fileType	= 'image/'.$imgArr2[count($imgArr2) - 1];
				
		$success	= false;

		if(! file_exists($imgFullPath))
		{
			//image file not found. skip avatar process.
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Avatar image file <strong>' . $cbImagePath . '</strong> not found.</div>");' );		
		}
		else if(! cValidImage( $imgFullPath ) )
		{
			//do not do anything.
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Avatar image file <strong>' . $cbImagePath . '</strong> not supported.</div>");' );
		} 
		else 
		{
			//$imageSize		= @cImageGetSize( $imgFullPath );
			
			// @todo: configurable width?
			$imageMaxWidth	= 160;			

			// Get a hash for the file name.
			$fileName		= JUtility::getHash( $imgFullPath . time() );
			$hashFileName	= JString::substr( $fileName , 0 , 24 );

			//@todo: configurable path for avatar storage?
			$storage			= JPATH_ROOT . DS . 'images' . DS . 'avatar';
			$storageImage		= $storage . DS . $hashFileName . cImageTypeToExt( $fileType );
			$storageThumbnail	= $storage . DS . 'thumb_' . $hashFileName . cImageTypeToExt( $fileType );
			$image				= 'images/avatar/' . $hashFileName . cImageTypeToExt( $fileType );
			$thumbnail			= 'images/avatar/' . 'thumb_' . $hashFileName . cImageTypeToExt( $fileType );						
			
			// Generate full image
			if(! cImageResizePropotional( $imgFullPath , $storageImage , $fileType , $imageMaxWidth ) )
			{				
				$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Error saving image file <strong>' . $cbImagePath . '</strong>!</div>");' );
			}
			
			// Generate thumbnail
			if(! cImageCreateThumb( $imgFullPath , $storageThumbnail , $fileType ))
			{				
				$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Error saving image file <strong>' . $cbImagePath . '</strong>!</div>");' );
			}
			
			//now update friend count.
			//JTable::addIncludePath( JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_jsmigrator');
			$tblUser	=& JTable::getInstance( 'jsusers', 'JsmigratorTable' );
			
			$tblUser->load( $userId );
			
			$tblUser->avatar	= $image;
			$tblUser->thumb		= $thumbnail;
			
			if($tblUser->store())
			{
				$success = true;
			}				
				
		}//end if else
		
		if($success)
		{
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Avatar for User ID <strong>' . $userId . '</strong>\' updated.</div>");' );
		}
		else
		{
			$objResponse->addScriptCall( 'jQuery("#progress-status").append("<div>Avatar for User ID <strong>' . $userId . '</strong>\' update failed!</div>");' );		
		}
	}			
	
}