<?php
/**
 * @package		JSMigrator
 * @copyright (C) 2008 by Slashes & Dots Sdn Bhd - All rights reserved!
 * @license http://www.azrul.com Copyrighted Commercial Software
 */

// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * This file and method will automatically get called by Joomla
 * during the installation process 
 **/
jimport( 'joomla.filesystem.folder' );

function com_install()
{
	$db		=& JFactory::getDBO();
	
	if( azrulSystemNeedsUpdate() )
	{
		// The path to the azrul.zip
		$zip			= dirname( JPATH_BASE ) . DS . 'components' . DS . 'com_jsmigrator' . DS . 'azrul.zip';
		$destination	= JPATH_PLUGINS . DS . 'system';
		
		if( !extractArchive( $zip , $destination ) )
		{
?>
			<div style="color: red; font-weight: 700;">Notice:</div>
			<div>
				There was an error while trying to extract the contents of "Azrul System Mambot".
				Please ensure that the path <strong><?php echo $destination; ?></strong> has correct permissions.
			</div>
<?php
			return;
		}
		
		// Insert the plugin row into the plugins table to tell joomla to load it.
		$query	= 'SELECT COUNT(*) FROM ' . $db->nameQuote( '#__plugins' ) . ' '
				. 'WHERE ' . $db->nameQuote( 'element' ) . '=' . $db->Quote( 'azrul.system' );
		$db->setQuery( $query );
		$recordExists	= $db->loadResult();
		
		if($db->getErrorNum())
		{
			JError::raiseError( 500, $db->stderr());
		}

		if( !$recordExists )
		{
			// Try to remove the old record.
			$plugin	= new stdClass();
			$plugin->name		= 'Azrul System Mambot';
			$plugin->element	= 'azrul.system';
			$plugin->folder		= 'system';
			$plugin->published	= 1;
			
			if(!$db->insertObject( '#__plugins' , $plugin ) )
			{
?>
			<div>
				Error while adding the plugin data into Joomla's plugin table.
			</div>
<?php
			}
		}
	}
	
	// Need to update the menu's component id if this is a reinstall
	if( menuNeedsUpdate() )
	{
		if( !updateMenuItems() )
		{
		?>
		<p style="font-weight: 700; color: red;">
			System encountered an error while trying to update the existing menu items. You will need
			to update the existing menu structure manually.
		</p>
		<?php
		}
	}
}



/**
 * Method to update menu's component id.
 *
 * @return boolean true on success false on failure.
 */
function updateMenuItems()
{
	// Get new component id.
	$db 	=& JFactory::getDBO();
	
	$query 	= 'SELECT ' . $db->nameQuote( 'id' ) . ' '
			. 'FROM ' . $db->nameQuote( '#__components' ) . ' AS a '
			. 'WHERE a.option=' . $db->Quote( 'com_jsmigrator' ) . ' '
			. 'AND a.parent=' . $db->Quote( '0');
	$db->setQuery( $query );
	
	$newId 	= $db->loadResult();
	
	if( !$newId )
		return false;
		
	// Update the existing menu items.
	$query 	= 'UPDATE ' . $db->nameQuote( '#__menu' ) . ' '
			. 'SET componentid=' . $db->Quote( $newId ) . ' '
			. 'WHERE link LIKE ' . $db->Quote('%option=com_jsmigrator%');

	$db->setQuery( $query );
	$db->query();
	
	return true;
}

function menuNeedsUpdate()
{
	$db		=& JFactory::getDBO();
	
	$query	= 'SELECT COUNT(*) FROM ' . $db->nameQuote( '#__menu' ) . ' '
			. 'WHERE ' . $db->nameQuote( 'link' ) . ' LIKE ' .  $db->Quote( '%option=com_jsmigrator%');

	$db->setQuery( $query );

	$needUpdate	= ( $db->loadResult() > 1 ) ? true : false;
	
	return $needUpdate;
}
	
/**
 * Method to extract archive out
 * 
 * @returns	boolean	True on success false otherwise.
 **/ 
function extractArchive( $source , $destination )
{
	// Cleanup path
	$destination	= JPath::clean( $destination );
	$source			= JPath::clean( $source );

	return JArchive::extract( $source , $destination );
}

/**
 * Method to check if the system plugins exists
 * 
 * @returns boolean	True if system plugin needs update, false otherwise.
 **/ 
function azrulSystemNeedsUpdate()
{
	$xml	= JPATH_PLUGINS . DS . 'system' . DS . 'azrul.system.xml';
	
	// Test if file exists
	if( file_exists( $xml ) )
	{
		// Load the parser and the XML file
		$parser		=& JFactory::getXMLParser( 'Simple' );
		$parser->loadFile( $xml );
		$document	=& $parser->document;

		$element	=& $document->getElementByPath( 'version' );
		$version	= doubleval( $element->data() );

		if( $version >= 2.7 && $version != 0 )
			return false;
	}
	
	return true;
}